import Parser from '../class/abstract';
import { type Get, type LazyGet, type Throw } from '../function/action';
type CustomPredicate = Readonly<{
    value: unknown;
    predicate: (value: unknown) => boolean;
}>;
declare function parseAsCustom<C, E extends Error>(options: Throw<E> & CustomPredicate): C;
declare function parseAsCustom<C, T>(options: (Get<T> | LazyGet<T>) & CustomPredicate): T | C;
declare class CustomParser<C = unknown> extends Parser<C> {
    private readonly predicate;
    constructor(value: unknown, predicate: CustomPredicate['predicate']);
    elseGet: <A>(alternativeValue: A) => C | A;
    elseLazyGet: <A>(alternativeValue: () => A) => C | A;
    elseThrow: <E extends Error>(message: string | E) => C;
}
export { parseAsCustom, CustomParser };
