import Parser from '../class/abstract';
import { type Get, type LazyGet, type Throw } from '../function/action';
import { type RangeOf } from '../helper';
type S = string;
type StringOptions = Readonly<{
    string: unknown;
    numberOfCharactersInRangeOf?: RangeOf;
}>;
declare function parseAsString<E extends Error>(options: Throw<E> & StringOptions): S;
declare function parseAsString<T>(options: (Get<T> | LazyGet<T>) & StringOptions): T | S;
declare class StringParser extends Parser<S> {
    private range;
    constructor(value: unknown);
    readonly numberOfCharactersInRangeOf: (rangeOf: RangeOf) => this;
    elseThrow: <E extends Error>(message: string | E) => S;
    elseGet: <A>(alternativeValue: A) => string | A;
    elseLazyGet: <A>(alternativeValue: () => A) => string | A;
}
export { StringParser, parseAsString };
