import Parser from '../class/abstract';
import { type Get, type LazyGet, type Throw } from '../function/action';
type B = boolean;
type BooleanOptions = Readonly<{
    boolean: unknown;
}>;
declare function parseAsBoolean<E extends Error>(options: Throw<E> & BooleanOptions): B;
declare function parseAsBoolean<T>(options: (Get<T> | LazyGet<T>) & BooleanOptions): T | B;
declare class BooleanParser extends Parser<B> {
    constructor(value: unknown);
    elseGet: <A>(alternativeValue: A) => boolean | A;
    elseLazyGet: <A>(alternativeValue: () => A) => boolean | A;
    elseThrow: <E extends Error>(message: string | E) => B;
}
export { BooleanParser, parseAsBoolean };
