import Parser from '../class/abstract';
import { type Get, type LazyGet, type Throw } from '../function/action';
import { type RangeOf } from '../helper';
type N = number;
type NumberOptions = Readonly<{
    number: unknown;
    inRangeOf?: RangeOf;
}>;
declare function parseAsNumber<E extends Error>(options: Throw<E> & NumberOptions): N;
declare function parseAsNumber<T>(options: (Get<T> | LazyGet<T>) & NumberOptions): T | N;
declare class NumberParser extends Parser<N> {
    private range;
    constructor(value: unknown);
    readonly inRangeOf: (rangeOf: RangeOf) => this;
    elseThrow: <E extends Error>(message: string | E) => N;
    elseGet: <A>(alternativeValue: A) => number | A;
    elseLazyGet: <A>(alternativeValue: () => A) => number | A;
}
export { NumberParser, parseAsNumber };
